Index: trunk/LMDZ.COMMON/libf/evolution/read_data_PCM_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/read_data_PCM_mod.F90	(revision 3570)
+++ trunk/LMDZ.COMMON/libf/evolution/read_data_PCM_mod.F90	(revision 3571)
@@ -15,7 +15,6 @@
 !=======================================================================
 
-SUBROUTINE read_data_PCM(filename,timelen,iim_input,jjm_input,ngrid,nslope,vmr_co2_PCM_phys,ps_timeseries, &
-                         min_co2_ice,min_h2o_ice,tsurf_avg,tsoil_avg,tsurf_PCM,tsoil_PCM,q_co2,q_h2o,      &
-                         watersurf_density_avg,watersoil_density)
+SUBROUTINE read_data_PCM(filename1,filename2,timelen,iim_input,jjm_input,ngrid,nslope,vmr_co2_PCM,ps_timeseries,ps_avg,tsurf_avg_yr1,tsurf_avg, &
+                         tsoil_avg,tsoil_timeseries,min_co2_ice,min_h2o_ice,q_co2,q_h2o,watersurf_density_avg,watersoil_density_timeseries)
 use comsoil_h,             only: nsoilmx
 use comsoil_h_PEM,         only: soil_pem
@@ -34,39 +33,38 @@
 
 !=======================================================================
-! Arguments:
-character(*), intent(in) :: filename                            ! File name
-integer,      intent(in) :: timelen                             ! number of times stored in the file
-integer,      intent(in) :: iim_input, jjm_input, ngrid, nslope ! number of points in the lat x lon dynamical grid, number of subgrid slopes
+! Inputs:
+character(*), intent(in) :: filename1, filename2                ! File names
+integer,      intent(in) :: timelen                             ! Number of times stored in the file
+integer,      intent(in) :: iim_input, jjm_input, ngrid, nslope ! Number of points in the lat x lon dynamical grid, number of subgrid slopes
 ! Ouputs
-real, dimension(ngrid,nslope),         intent(out) :: min_co2_ice      ! Minimum of co2 ice per slope of the year [kg/m^2]
-real, dimension(ngrid,nslope),         intent(out) :: min_h2o_ice      ! Minimum of h2o ice per slope of the year [kg/m^2]
-real, dimension(ngrid,timelen),        intent(out) :: vmr_co2_PCM_phys ! Physics x Times co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
-real, dimension(ngrid,timelen),        intent(out) :: ps_timeseries    ! Surface Pressure [Pa]
-real, dimension(ngrid,timelen),        intent(out) :: q_co2            ! CO2 mass mixing ratio in the first layer [kg/m^3]
-real, dimension(ngrid,timelen),        intent(out) :: q_h2o            ! H2O mass mixing ratio in the first layer [kg/m^3]
-!SOIL
-real, dimension(ngrid,nslope),                 intent(out) :: tsurf_avg             ! Average surface temperature of the concatenated file [K]
-real, dimension(ngrid,nsoilmx,nslope),         intent(out) :: tsoil_avg             ! Average soil temperature of the concatenated file [K]
-real, dimension(ngrid,nslope,timelen),         intent(out) :: tsurf_PCM             ! Surface temperature of the concatenated file, time series [K]
-real, dimension(ngrid,nsoilmx,nslope,timelen), intent(out) :: tsoil_PCM             ! Soil temperature of the concatenated file, time series [K]
-real, dimension(ngrid,nslope),                 intent(out) :: watersurf_density_avg ! Water density at the surface [kg/m^3]
-real, dimension(ngrid,nsoilmx,nslope,timelen), intent(out) :: watersoil_density     ! Water density in the soil layer, time series [kg/m^3]
-!=======================================================================
-! Local Variables
-integer                         :: i, j, l, t                                                    ! loop variables
-real                            :: A, B, mmean                                                   ! Molar Mass of co2 and no co2, A;B intermediate variables to compute the mean molar mass of the layer
-integer                         :: islope                                                        ! loop for variables
-character(2)                    :: num                                                           ! for reading sloped variables
-real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: h2o_ice_s_dyn             ! h2o ice per slope of the concatenated file [kg/m^2]
+real, dimension(ngrid,nslope,2),               intent(out) :: min_co2_ice                  ! Minimum of co2 ice per slope of the year [kg/m^2]
+real, dimension(ngrid,nslope,2),               intent(out) :: min_h2o_ice                  ! Minimum of h2o ice per slope of the year [kg/m^2]
+real, dimension(ngrid,timelen),                intent(out) :: vmr_co2_PCM                  ! Grid points x Times co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
+real, dimension(ngrid,timelen),                intent(out) :: q_co2                        ! CO2 mass mixing ratio in the first layer [kg/m^3]
+real, dimension(ngrid,timelen),                intent(out) :: q_h2o                        ! H2O mass mixing ratio in the first layer [kg/m^3]
+real, dimension(ngrid,timelen),                intent(out) :: ps_timeseries                ! Surface pressure timeseries [Pa]
+real, dimension(ngrid),                        intent(out) :: ps_avg                       ! Averaged surface pressure [K]
+real, dimension(ngrid,nslope),                 intent(out) :: tsurf_avg                    ! Averaged surface temperature [K]
+real, dimension(ngrid,nslope),                 intent(out) :: tsurf_avg_yr1                ! Averaged surface temperature for year 1 [K]
+real, dimension(ngrid,nsoilmx,nslope),         intent(out) :: tsoil_avg                    ! Averaged soil temperature for year 2 [K]
+real, dimension(ngrid,nsoilmx,nslope,timelen), intent(out) :: tsoil_timeseries             ! Soil temperature timeseries [K]
+real, dimension(ngrid,nslope),                 intent(out) :: watersurf_density_avg        ! Water density at the surface [kg/m^3]
+real, dimension(ngrid,nsoilmx,nslope,timelen), intent(out) :: watersoil_density_timeseries ! Water density timeseries in the soil layer [kg/m^3]
+! Local variables
+integer                                                             :: i, j, l, t, islope        ! Loop variables
+real                                                                :: A, B, mmean               ! Molar Mass of co2 and no co2, A;B intermediate variables to compute the mean molar mass of the layer
+character(2)                                                        :: num                       ! Hor reading sloped variables
+real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: h2o_ice_s_dyn             ! H2O ice per slope of the concatenated file [kg/m^2]
 real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: watercap
 real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: perennial_co2ice
-real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: vmr_co2_PCM               ! CO2 volume mixing ratio in the first layer [mol/m^3]
-real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: ps_PCM                    ! Surface Pressure [Pa]
+real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: vmr_co2_dyn               ! CO2 volume mixing ratio in the first layer [mol/m^3]
+real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: ps_dyn                   ! Surface pressure [Pa]
+real, dimension(iim_input + 1,jjm_input + 1)                        :: ps_avg_dyn                ! Averaged surface pressure of the concatenated file [Pa]
 real, dimension(iim_input + 1,jjm_input + 1,nslope)                 :: min_co2_ice_dyn
 real, dimension(iim_input + 1,jjm_input + 1,nslope)                 :: min_h2o_ice_dyn
-real, dimension(iim_input + 1,jjm_input + 1,nslope)                 :: tsurf_avg_dyn             ! Average surface temperature of the concatenated file [K]
-real, dimension(iim_input + 1,jjm_input + 1,nsoilmx,nslope)         :: tsoil_avg_dyn             ! Average soil temperature of the concatenated file [K]
-real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: tsurf_PCM_dyn             ! Surface temperature of the concatenated file, time series [K]
-real, dimension(iim_input + 1,jjm_input + 1,nsoilmx,nslope,timelen) :: tsoil_PCM_dyn             ! Soil temperature of the concatenated file, time series [K]
+real, dimension(iim_input + 1,jjm_input + 1,nslope)                 :: tsurf_avg_dyn             ! Averaged surface temperature of the concatenated file [K]
+real, dimension(iim_input + 1,jjm_input + 1,nsoilmx,nslope)         :: tsoil_avg_dyn             ! Averaged soil temperature of the concatenated file [K]
+real, dimension(iim_input + 1,jjm_input + 1,nslope,timelen)         :: tsurf_dyn                ! Surface temperature of the concatenated file, time series [K]
+real, dimension(iim_input + 1,jjm_input + 1,nsoilmx,nslope,timelen) :: tsoil_dyn                ! Soil temperature of the concatenated file, time series [K]
 real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: q_co2_dyn                 ! CO2 mass mixing ratio in the first layer [kg/m^3]
 real, dimension(iim_input + 1,jjm_input + 1,timelen)                :: q_h2o_dyn                 ! H2O mass mixing ratio in the first layer [kg/m^3]
@@ -76,18 +74,12 @@
 real, dimension(iim_input + 1,jjm_input + 1,nsoilmx,nslope,timelen) :: watersoil_density_dyn     ! Water density in the soil layer, time series [kg/m^3]
 !-----------------------------------------------------------------------
+
+!------------------ Year 1 ------------------
 ! Open the NetCDF file
-write(*,*) "Opening "//filename//"..."
-call error_msg(NF90_OPEN(filename,NF90_NOWRITE,fID),"open",filename)
-
-! Download the data from the file
-call get_var3("ps",ps_PCM)
-write(*,*) "Data for surface pressure downloaded!"
-
-call get_var3("co2_layer1",q_co2_dyn)
-write(*,*) "Data for vmr co2 downloaded!"
-
-call get_var3("h2o_layer1",q_h2o_dyn)
-write(*,*) "Data for vmr h2o downloaded!"
-
+write(*,*) "Opening "//filename1//"..."
+call error_msg(NF90_OPEN(filename1,NF90_NOWRITE,fID),"open",filename1)
+
+! Compute averages over the year for each point
+write(*,*) "Computing the average of tsurf..."
 if (nslope == 1) then ! There is no slope
     call get_var3("co2ice",co2_ice_slope_dyn(:,:,1,:))
@@ -97,5 +89,5 @@
     write(*,*) "Data for h2o_ice_s downloaded!"
 
-    call get_var3("tsurf",tsurf_PCM_dyn(:,:,1,:))
+    call get_var3("tsurf",tsurf_dyn(:,:,1,:))
     write(*,*) "Data for tsurf downloaded!"
 
@@ -106,15 +98,4 @@
     call get_var3("perennial_co2ice",perennial_co2ice(:,:,1,:))
     write(*,*) "Data for perennial_co2ice downloaded!"
-
-    if (soil_pem) then
-        call get_var4("soiltemp",tsoil_PCM_dyn(:,:,:,1,:))
-        write(*,*) "Data for soiltemp downloaded!"
-
-        call get_var4("waterdensity_soil",watersoil_density_dyn(:,:,:,1,:))
-        write(*,*) "Data for waterdensity_soil downloaded!"
-
-        call get_var3("waterdensity_surface",watersurf_density_dyn(:,:,1,:))
-        write(*,*) "Data for waterdensity_surface downloaded!"
-    endif !soil_pem
 #endif
 else ! We use slopes
@@ -133,5 +114,5 @@
     do islope = 1,nslope
         write(num,'(i2.2)') islope
-        call get_var3("tsurf_slope"//num,tsurf_PCM_dyn(:,:,islope,:))
+        call get_var3("tsurf_slope"//num,tsurf_dyn(:,:,islope,:))
     enddo
     write(*,*) "Data for tsurf downloaded!"
@@ -149,30 +130,10 @@
     enddo
     write(*,*) "Data for perennial_co2ice downloaded!"
-
-    if (soil_pem) then
-        do islope = 1,nslope
-            write(num,'(i2.2)') islope
-            call get_var4("soiltemp_slope"//num,tsoil_PCM_dyn(:,:,:,islope,:))
-        enddo
-        write(*,*) "Data for soiltemp downloaded!"
-
-        do islope = 1,nslope
-            write(num,'(i2.2)') islope
-            call get_var4("waterdensity_soil_slope"//num,watersoil_density_dyn(:,:,:,islope,:))
-        enddo
-        write(*,*) "Data for waterdensity_soil downloaded!"
-
-        do islope = 1,nslope
-            write(num,'(i2.2)') islope
-            call get_var3("waterdensity_surface"//num,watersurf_density_dyn(:,:,islope,:))
-        enddo
-        write(*,*) "Data for waterdensity_surface downloaded!"
-    endif !soil_pem
 #endif
 endif
 
 ! Close the NetCDF file
-write(*,*) "Closing "//filename//"..."
-call error_msg(nf90_close(fID),"close",filename)
+write(*,*) "Closing "//filename1//"..."
+call error_msg(nf90_close(fID),"close",filename1)
 
 ! Compute the minimum over the year for each point
@@ -186,10 +147,140 @@
 ! Compute averages over the year for each point
 write(*,*) "Computing the average of tsurf..."
-tsurf_avg_dyn = sum(tsurf_PCM_dyn,4)/timelen
+tsurf_avg_dyn = sum(tsurf_dyn,4)/timelen
+
+#ifndef CPP_1D
+    call gr_dyn_fi(nslope,iim_input + 1,jjm_input + 1,ngrid,tsurf_avg_dyn,tsurf_avg)
+    do islope = 1,nslope
+        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_co2_ice_dyn(:,:,islope),min_co2_ice(:,islope,1))
+        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_h2o_ice_dyn(:,:,islope),min_h2o_ice(:,islope,1))
+    enddo
+#else
+    tsurf_avg_yr1(1,:) = tsurf_avg_dyn(1,1,:)
+    min_co2_ice(1,:,1) = min_co2_ice_dyn(1,1,:)
+    min_h2o_ice(1,:,1) = min_h2o_ice_dyn(1,1,:)
+#endif
+write(*,*) "Downloading data Y1 done!"
+
+!------------------ Year 2 ------------------
+
+! Open the NetCDF file
+write(*,*) "Opening "//filename2//"..."
+call error_msg(NF90_OPEN(filename2,NF90_NOWRITE,fID),"open",filename2)
+
+! Download the data from the file
+call get_var3("ps",ps_dyn)
+write(*,*) "Data for surface pressure downloaded!"
+
+call get_var3("co2_layer1",q_co2_dyn)
+write(*,*) "Data for vmr co2 downloaded!"
+
+call get_var3("h2o_layer1",q_h2o_dyn)
+write(*,*) "Data for vmr h2o downloaded!"
+
+if (nslope == 1) then ! There is no slope
+    call get_var3("co2ice",co2_ice_slope_dyn(:,:,1,:))
+    write(*,*) "Data for co2_ice downloaded!"
+
+    call get_var3("h2o_ice_s",h2o_ice_s_dyn(:,:,1,:))
+    write(*,*) "Data for h2o_ice_s downloaded!"
+
+    call get_var3("tsurf",tsurf_dyn(:,:,1,:))
+    write(*,*) "Data for tsurf downloaded!"
+
+#ifndef CPP_STD
+    call get_var3("watercap",watercap(:,:,1,:))
+    write(*,*) "Data for watercap downloaded!"
+
+    call get_var3("perennial_co2ice",perennial_co2ice(:,:,1,:))
+    write(*,*) "Data for perennial_co2ice downloaded!"
+
+    if (soil_pem) then
+        call get_var4("soiltemp",tsoil_dyn(:,:,:,1,:))
+        write(*,*) "Data for soiltemp downloaded!"
+
+        call get_var4("waterdensity_soil",watersoil_density_dyn(:,:,:,1,:))
+        write(*,*) "Data for waterdensity_soil downloaded!"
+
+        call get_var3("waterdensity_surface",watersurf_density_dyn(:,:,1,:))
+        write(*,*) "Data for waterdensity_surface downloaded!"
+    endif !soil_pem
+#endif
+else ! We use slopes
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_var3("co2ice_slope"//num,co2_ice_slope_dyn(:,:,islope,:))
+    enddo
+    write(*,*) "Data for co2_ice downloaded!"
+
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_var3("h2o_ice_s_slope"//num,h2o_ice_s_dyn(:,:,islope,:))
+    enddo
+    write(*,*) "Data for h2o_ice_s downloaded!"
+
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_var3("tsurf_slope"//num,tsurf_dyn(:,:,islope,:))
+    enddo
+    write(*,*) "Data for tsurf downloaded!"
+
+#ifndef CPP_STD
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_var3("watercap_slope"//num,watercap(:,:,islope,:))
+    enddo
+    write(*,*) "Data for watercap downloaded!"
+
+    do islope = 1,nslope
+        write(num,'(i2.2)') islope
+        call get_var3("perennial_co2ice_slope"//num,perennial_co2ice(:,:,islope,:))
+    enddo
+    write(*,*) "Data for perennial_co2ice downloaded!"
+
+    if (soil_pem) then
+        do islope = 1,nslope
+            write(num,'(i2.2)') islope
+            call get_var4("soiltemp_slope"//num,tsoil_dyn(:,:,:,islope,:))
+        enddo
+        write(*,*) "Data for soiltemp downloaded!"
+
+        do islope = 1,nslope
+            write(num,'(i2.2)') islope
+            call get_var4("waterdensity_soil_slope"//num,watersoil_density_dyn(:,:,:,islope,:))
+        enddo
+        write(*,*) "Data for waterdensity_soil downloaded!"
+
+        do islope = 1,nslope
+            write(num,'(i2.2)') islope
+            call get_var3("waterdensity_surface"//num,watersurf_density_dyn(:,:,islope,:))
+        enddo
+        write(*,*) "Data for waterdensity_surface downloaded!"
+    endif !soil_pem
+#endif
+endif
+
+! Close the NetCDF file
+write(*,*) "Closing "//filename2//"..."
+call error_msg(nf90_close(fID),"close",filename2)
+
+! Compute the minimum over the year for each point
+write(*,*) "Computing the min of h2o_ice..."
+where (h2o_ice_s_dyn < 0.) h2o_ice_s_dyn = 0.
+min_h2o_ice_dyn = minval(h2o_ice_s_dyn + watercap,4)
+write(*,*) "Computing the min of co2_ice..."
+where (co2_ice_slope_dyn < 0.) co2_ice_slope_dyn = 0.
+min_co2_ice_dyn = minval(co2_ice_slope_dyn + perennial_co2ice,4)
+
+! Compute averages over the year for each point
+write(*,*) "Computing the average of tsurf..."
+tsurf_avg_dyn = sum(tsurf_dyn,4)/timelen
+
+write(*,*) "Computing the average of Ps..."
+ps_avg_dyn = sum(ps_dyn,3)/timelen
 
 if (soil_pem) then
-    write(*,*) "Computing average of tsoil..."
-    tsoil_avg_dyn = sum(tsoil_PCM_dyn,5)/timelen
-    write(*,*) "Computing average of waterdensity_surface..."
+    write(*,*) "Computing the average of tsoil..."
+    tsoil_avg_dyn = sum(tsoil_dyn,5)/timelen
+    write(*,*) "Computing the average of waterdensity_surface..."
     watersurf_density_dyn_avg = sum(watersurf_density_dyn,4)/timelen
 endif
@@ -212,5 +303,5 @@
             endif
             mmean = 1/(A*q_co2_dyn(i,j,t) + B)
-            vmr_co2_PCM(i,j,t) = q_co2_dyn(i,j,t)*mmean/m_co2
+            vmr_co2_dyn(i,j,t) = q_co2_dyn(i,j,t)*mmean/m_co2
         enddo
     enddo
@@ -218,44 +309,41 @@
 
 #ifndef CPP_1D
-    call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,vmr_co2_PCM,vmr_co2_PCM_phys)
-    call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,ps_PCM,ps_timeseries)
+    call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,vmr_co2_dyn,vmr_co2_PCM)
+    call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,ps_dyn,ps_timeseries)
+    call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,ps_avg_dyn,ps_avg)
     call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,q_co2_dyn,q_co2)
     call gr_dyn_fi(timelen,iim_input + 1,jjm_input + 1,ngrid,q_h2o_dyn,q_h2o)
-
-    do islope = 1,nslope
-        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_co2_ice_dyn(:,:,islope),min_co2_ice(:,islope))
-        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_h2o_ice_dyn(:,:,islope),min_h2o_ice(:,islope))
+    do islope = 1,nslope
+        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_co2_ice_dyn(:,:,islope),min_co2_ice(:,islope,2))
+        call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,min_h2o_ice_dyn(:,:,islope),min_h2o_ice(:,islope,2))
         if (soil_pem) then
             do l = 1,nsoilmx
                 call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,tsoil_avg_dyn(:,:,l,islope),tsoil_avg(:,l,islope))
                 do t = 1,timelen
-                    call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,tsoil_PCM_dyn(:,:,l,islope,t),tsoil_PCM(:,l,islope,t))
-                    call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,watersoil_density_dyn(:,:,l,islope,t),watersoil_density(:,l,islope,t))
+                    call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,tsoil_dyn(:,:,l,islope,t),tsoil_timeseries(:,l,islope,t))
+                    call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,watersoil_density_dyn(:,:,l,islope,t),watersoil_density_timeseries(:,l,islope,t))
                 enddo
             enddo
             call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,watersurf_density_dyn_avg(:,:,islope),watersurf_density_avg(:,islope))
         endif ! soil_pem
-        do t = 1,timelen
-            call gr_dyn_fi(1,iim_input + 1,jjm_input + 1,ngrid,tsurf_PCM_dyn(:,:,islope,t),tsurf_PCM(:,islope,t))
-        enddo
-    enddo
-
+    enddo
     call gr_dyn_fi(nslope,iim_input + 1,jjm_input + 1,ngrid,tsurf_avg_dyn,tsurf_avg)
 #else
-    vmr_co2_PCM_phys(1,:) = vmr_co2_PCM(1,1,:)
-    ps_timeseries(1,:) = ps_PCM(1,1,:)
+    vmr_co2_PCM(1,:) = vmr_co2_dyn(1,1,:)
+    ps_timeseries(1,:) = ps_dyn(1,1,:)
+    ps_avg(1) = ps_avg_dyn(1,1)
     q_co2(1,:) = q_co2_dyn(1,1,:)
     q_h2o(1,:) = q_h2o_dyn(1,1,:)
-    min_co2_ice(1,:) = min_co2_ice_dyn(1,1,:)
-    min_h2o_ice(1,:) = min_h2o_ice_dyn(1,1,:)
+    min_co2_ice(1,:,2) = min_co2_ice_dyn(1,1,:)
+    min_h2o_ice(1,:,2) = min_h2o_ice_dyn(1,1,:)
     if (soil_pem) then
+        tsoil_timeseries(1,:,:,:) = tsoil_dyn(1,1,:,:,:)
         tsoil_avg(1,:,:) = tsoil_avg_dyn(1,1,:,:)
-        tsoil_PCM(1,:,:,:) = tsoil_PCM_dyn(1,1,:,:,:)
-        watersoil_density(1,:,:,:) = watersoil_density_dyn(1,1,:,:,:)
+        watersoil_density_timeseries(1,:,:,:) = watersoil_density_dyn(1,1,:,:,:)
         watersurf_density_avg(1,:) = watersurf_density_dyn_avg(1,1,:)
     endif ! soil_pem
-    tsurf_PCM(1,:,:) = tsurf_PCM_dyn(1,1,:,:)
     tsurf_avg(1,:) = tsurf_avg_dyn(1,1,:)
 #endif
+write(*,*) "Downloading data Y2 done!"
 
 END SUBROUTINE read_data_PCM
Index: trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_mod.F90	(revision 3571)
+++ trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_mod.F90	(revision 3571)
@@ -0,0 +1,97 @@
+MODULE recomp_tend_co2_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE recomp_tend_co2(ngrid,nslope,timelen,d_co2ice_phys,d_co2ice_ini,co2ice,emissivity, &
+                           vmr_co2_PCM,vmr_co2_PEM,ps_PCM,ps_avg_global_ini,ps_avg_global)
+
+use constants_marspem_mod, only : alpha_clap_co2, beta_clap_co2, sigmaB, Lco2, sols_per_my, sec_per_sol
+
+implicit none
+
+!=======================================================================
+!
+!  Routine that compute the evolution of the tendencie for co2 ice
+!
+!=======================================================================
+
+! Inputs
+! ------
+integer,                        intent(in) :: timelen, ngrid, nslope
+real, dimension(ngrid,timelen), intent(in) :: vmr_co2_PCM       ! physical point field: Volume mixing ratio of co2 in the first layer
+real, dimension(ngrid,timelen), intent(in) :: vmr_co2_PEM       ! physical point field: Volume mixing ratio of co2 in the first layer
+real, dimension(ngrid,timelen), intent(in) :: ps_PCM            ! physical point field: Surface pressure in the PCM
+real,                           intent(in) :: ps_avg_global_ini ! global averaged pressure at previous timestep
+real,                           intent(in) :: ps_avg_global     ! global averaged pressure at current timestep
+real, dimension(ngrid,nslope),  intent(in) :: d_co2ice_ini      ! physical point field: Evolution of perennial ice over one year
+real, dimension(ngrid,nslope),  intent(in) :: co2ice            ! CO2 ice per mesh and sub-grid slope (kg/m^2)
+real, dimension(ngrid,nslope),  intent(in) :: emissivity        ! Emissivity per mesh and sub-grid slope(1)
+! Outputs
+! -------
+real, dimension(ngrid,nslope), intent(inout) :: d_co2ice_phys ! physical point field: Evolution of perennial ice over one year
+
+! Local:
+! ------
+integer :: i, t, islope
+real    :: coef, avg
+
+write(*,*) "Update of the CO2 tendency from the current pressure"
+
+! Evolution of the water ice for each physical point
+do i = 1,ngrid
+    do islope = 1,nslope
+        coef = sols_per_my*sec_per_sol*emissivity(i,islope)*sigmaB/Lco2
+        avg = 0.
+        if (co2ice(i,islope) > 1.e-4 .and. abs(d_co2ice_phys(i,islope)) > 1.e-5) then
+            do t = 1,timelen
+                avg = avg + (beta_clap_co2/(alpha_clap_co2-log(vmr_co2_PCM(i,t)*ps_PCM(i,t)/100.)))**4 &
+                      - (beta_clap_co2/(alpha_clap_co2-log(vmr_co2_PEM(i,t)*ps_PCM(i,t)*(ps_avg_global/ps_avg_global_ini)/100.)))**4
+            enddo
+            if (avg < 1.e-4) avg = 0.
+            d_co2ice_phys(i,islope) = d_co2ice_ini(i,islope) - coef*avg/timelen
+        endif
+    enddo
+enddo
+
+END SUBROUTINE recomp_tend_co2
+!=======================================================================
+
+SUBROUTINE recomp_tend_h2o(ngrid,nslope,timelen,d_h2oice,PCM_temp,PEM_temp)
+
+implicit none
+
+!=======================================================================
+!
+!  Routine that compute the evolution of the tendencie for h2o ice
+!
+!=======================================================================
+
+! Inputs
+! ------
+integer,            intent(in) :: timelen, ngrid, nslope
+real, dimension(:), intent(in) :: PCM_temp, PEM_temp
+! Outputs
+! -------
+real, dimension(ngrid,nslope), intent(inout) :: d_h2oice ! physical point field: Evolution of perennial ice over one year
+
+! Local:
+! ------
+
+write(*,*) "Update of the H2O tendency due to lag layer"
+
+! Flux correction due to lag layer
+!~ Rz_old = h2oice_depth_old*0.0325/4.e-4              ! resistance from PCM
+!~ Rz_new = h2oice_depth_new*0.0325/4.e-4              ! new resistance based on new depth
+!~ R_dec = (1./Rz_old)/(1./Rz_new)                     ! decrease because of resistance
+!~ soil_psv_old = psv(max(PCM_temp(h2oice_depth_old))) ! the maxmimum annual mean saturation vapor pressure at the temperature of the GCM run temperature at the old ice location
+!~ soil_psv_new = psv(max(PEM_temp(h2oice_depth_new))) ! the maxmimum annual mean saturation vapor pressure at the temperature of the PEM run temperature at the new ice location
+!~ hum_dec = soil_psv_old/soil_psv_new                 ! decrease because of lower water vapor pressure at the new depth
+!~ d_h2oice = d_h2oice*R_dec*hum_dec                   ! decrease of flux
+
+END SUBROUTINE recomp_tend_h2o
+
+END MODULE recomp_tend_co2_mod
